<template>
  <section class="sign-up-form">
    <h2 class="text-center">Create character</h2>
    <form action="" method="post">
      <div class="form-group">
        <label for="inputLogin">Name</label>
        <input
          id="inputName"
          v-model="name"
          type="text"
          class="form-control">
      </div>
      <label>Class</label>
      <table class="w-100">
        <tr>
          <td v-for="game_class in game_classes" class="w-25 px-2">
            <button type="button" class="btn btn-block btn-outline-secondary" @click="game_class_id = game_class.id" style="height: 150px">
              {{ game_class.name }}
            </button>
          </td>
        </tr>
      </table>
      <hr>
      <div>
        <p
          class="submit-error text-danger"
          v-if="submitError">
          Ocorreu um erro na submissão.
        </p>
      </div>
      <nuxt-link to="/home" class="btn btn-outline-secondary">
        Back
      </nuxt-link>
      <button
        :class="btnClass"
        type="submit"
        @click.prevent="submit"
        :disabled="submitting">
        Create
      </button>
    </form>
  </section>
</template>

<script>

export default {
  created() {
    let ins = this;
    this.$axios({
      method: 'get',
      url: 'http://localhost:3000/game_classes'
    })
      .then(res => {
        this.game_classes = res.data;
      })
      .catch(err => {
        console.log(err);
      })
  },
  data() {
    return {
      submitError: false,
      submitting: false,
      btnClass: ["btn", "btn-secondary", "btn-submit", "btn-touch", "float-right"],
      name: '',
      game_classes: {},
      game_class_id: 3,
    };
  },
  computed: {
    user: {
      get() {
        return this.$store.state.user;
      },
    }
  },
  methods: {
    submit() {
      this.submitting = true;
      this.btnClass = this.btnClass.concat("btn-disabled");
      const info = {
        user_login: this.user.login,
        character: {
          name: this.name,
          level: 1,
          exp: 0,
          gold: 100,
          curr_location_id: 1,
          game_class_id: this.game_class_id
        }
      };

      let ins = this;
      this.$axios({
        method: 'post',
        url: `http://localhost:3000/users/${this.$store.state.user._id.$oid}/characters`,
        data: info
      })
        .then( res => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = false;

          ins.$store.state.user = res.data;

          // clear form data
          this.name = '';

          // redirect
          ins.$router.push('/home');
        })
        .catch( err => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = true;

          console.log(err);
        });
    }
  },
  components: {
  }
}
</script>
